package com.loafle.overflow.central.module.auth.service;

import com.loafle.overflow.central.module.auth.dao.AuthCrawlerDAO;

import com.loafle.overflow.central.module.infra.service.CentralInfraService;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.auth.AuthCrawler;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.meta.MetaCrawler;
import com.loafle.overflow.service.central.auth.AuthCrawlerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by snoop on 17. 8. 30.
 */
@Service("AuthCrawlerService")
public class CentralAuthCrawlerService implements AuthCrawlerService {

  @Autowired
  private AuthCrawlerDAO authCrawlerDAO;

  @Autowired
  private CentralInfraService infraService;

  public AuthCrawler regist(AuthCrawler authCrawler) {
    // if (authCrawler == null) {
    //   return this.authCrawlerDAO.save(authCrawler);
    // }

    AuthCrawler dbAuthCrawler = this.authCrawlerDAO.findByMetaCrawlerIdAndTargetId(authCrawler.getMetaCrawler().getId(),
        authCrawler.getTarget().getId());

    dbAuthCrawler.setAuthJson(authCrawler.getAuthJson());
    dbAuthCrawler.setMetaCrawler(authCrawler.getMetaCrawler());
    dbAuthCrawler.setTarget(authCrawler.getTarget());

    return this.authCrawlerDAO.save(dbAuthCrawler);
  }

  public boolean checkAuthCrawler(Long infraId, MetaCrawler metaCrawler, String authJson) throws OverflowException {

    Infra infra = this.infraService.read(infraId);

    // FIXME: Check Crawler on Probe

    return false;
  }

  public AuthCrawler readByMetaCrawlerIDAndTargetID(Short metaCrawlerID, Long targetID) throws OverflowException {

    return this.authCrawlerDAO.findByMetaCrawlerIdAndTargetId(metaCrawlerID, targetID);
  }

}
