package com.loafle.overflow.central.module.domain.service;

import com.loafle.overflow.central.module.domain.dao.DomainMemberDAO;

import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.domain.DomainMember;
import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.service.central.domain.DomainMemberService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
@Service("DomainMemberService")
public class CentralDomainMemberService implements DomainMemberService {

  @Autowired
  private DomainMemberDAO domainMemberDAO;

  public void regist(DomainMember domainMember) {
    this.domainMemberDAO.save(domainMember);
  }

  public Domain readDomainByMemberID(Long memberID) {
    return this.domainMemberDAO.findDomainByMemberId(memberID);
  }

  public DomainMember readByMemberEmail(String email) {
    return this.domainMemberDAO.findByMemberEmail(email);
  }

  public List<Member> readAllMemberByDomainID(final Long domainID) {
    return this.domainMemberDAO.findAllMemberByDomainId(domainID);
  }

}
