package com.loafle.overflow.central.module.history.service;

import com.loafle.overflow.central.commons.utils.PageUtil;
import com.loafle.overflow.central.module.history.dao.HistoryDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.history.History;
import com.loafle.overflow.model.meta.MetaHistoryType;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.service.central.history.HistoryService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

@Service("HistoryService")
public class CentralHistoryService implements HistoryService {
    @Autowired
    private HistoryDAO historyDAO;

    public History regist(History history) throws OverflowException {
        return this.historyDAO.save(history);
    }


    public Page<History> readAllByProbeIDAndMetaHistoryTypeID(Long probeID, Integer metaHistoryTypeID, PageParams pageParams) throws OverflowException {
        return this.historyDAO.findAllByProbeIdAndMetaHistoryTypeId(probeID, metaHistoryTypeID, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException {
        return this.historyDAO.findAllByProbeId(probeID, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException {
        return this.historyDAO.findAllByDomainId(domainID, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomainIDAndMetaHistoryTypeID(Long domainID, Integer metaHistoryTypeID, PageParams pageParams) throws OverflowException {
        return this.historyDAO.findAllByDomainIdAndMetaHistoryTypeId(domainID, metaHistoryTypeID, PageUtil.getPageRequest(pageParams));
    }

}
