package com.loafle.overflow.central.module.meta.service;

import com.loafle.overflow.central.module.meta.dao.MetaVendorCrawlerDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaInfraVendor;
import com.loafle.overflow.model.meta.MetaVendorCrawler;
import com.loafle.overflow.service.central.meta.MetaVendorCrawlerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by snoop on 17. 7. 27.
 */

@Service("MetaVendorCrawlerService")
public class CentralMetaVendorCrawlerService implements MetaVendorCrawlerService {

    @Autowired
    private MetaVendorCrawlerDAO crawlerDAO;

    public List<MetaVendorCrawler> readAllByMetaInfraVendorID(Integer metaInfraVendorID) throws OverflowException {

        return this.crawlerDAO.findAllByMetaInfraVendorId(metaInfraVendorID);
    }

    public MetaVendorCrawler regist(MetaVendorCrawler metaVendorCrawler) throws OverflowException {
        return this.crawlerDAO.save(metaVendorCrawler);
    }
}
