package com.loafle.overflow.central.module.auth.service;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.auth.AuthCrawler;
import com.loafle.overflow.model.meta.MetaCrawler;
import com.loafle.overflow.model.target.Target;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 8. 30.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class AuthCrawlerServiceTest {

    @Autowired
    private CentralAuthCrawlerService authCrawlerService;

    @Test
    public void regist() throws Exception {

        AuthCrawler authCrawler = new AuthCrawler();

        Target target = new Target();
        target.setId(Long.valueOf(4));

        authCrawler.setTarget(target);


        MetaCrawler metaCrawler = new MetaCrawler();
        metaCrawler.setId((short)11);

        authCrawler.setMetaCrawler(metaCrawler);

        authCrawler.setAuthJson("{\"DB Name\":\"test\",\"ID\":\"docker\",\"PassWord\":\"qwer5795QWER\"}");


        this.authCrawlerService.regist(authCrawler);

        Assert.assertNotEquals(authCrawler.getId().longValue(), 0);

    }

    @Test
    public void findAuth() throws OverflowException {
        AuthCrawler authCrawler = this.authCrawlerService.readByMetaCrawlerIDAndTargetID((short)23, Long.valueOf(5));

        Assert.assertNotEquals(authCrawler, null);

    }

}