package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.infra.InfraHost;
import com.loafle.overflow.model.infra.InfraOS;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.service.central.infra.InfraHostService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { AppConfigTest.class })
public class InfraHostServiceTest {

    @Autowired
    private InfraHostService infraHostService;

    @Autowired
    private ObjectMapper objectMapper;

    @Test
    // @Ignore
    public void regist() throws Exception {

        InfraHost infraHost = new InfraHost();

        infraHost.setMac("30-9C-23-15-A3-09");
        infraHost.setIpv4("192.168.1.1");
        InfraOS infraOS = new InfraOS();
        infraOS.setId(Long.valueOf(2));

        infraHost.setInfraOS(infraOS);

        MetaInfraType metaInfraType = new MetaInfraType(2);

        this.infraHostService.regist(infraHost);

        Assert.assertNotEquals(infraHost.getId().longValue(), 0);

    }

    @Test
    public void read() throws Exception {

        InfraHost infraHost = this.infraHostService.read(Long.valueOf(1));

        String json = objectMapper.writeValueAsString(infraHost);

        System.out.println(json);

    }

    @Test
    public void readByIp() {

        InfraHost infraHost;
        try {
            infraHost = this.infraHostService.readByProbeIdAndIpv4(Long.valueOf(1), "192.168.1.1");
            Assert.assertNotEquals(infraHost, null);
        } catch (OverflowException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

}