package com.loafle.overflow.central.module.infra.service;

import com.google.gson.Gson;
import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.infra.InfraMachine;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.service.central.infra.InfraMachineService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;


/**
 * Created by snoop on 17. 7. 27.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraMachineServiceTest {

    @Autowired
    private InfraMachineService infraMachineService;

    @Autowired
    private ObjectMapper objectMapper;

    //    @Ignore
    @Test
    public void regist() throws Exception {

        InfraMachine infraMachine = new InfraMachine();

        infraMachine.setMeta("i am a infra machine");

        MetaInfraType metaInfraType = new MetaInfraType(1);

        this.infraMachineService.regist(infraMachine);

        Assert.assertNotEquals(infraMachine.getId().longValue(), 0);

    }

    @Test
    public void read() throws Exception {

//        regist();

        InfraMachine infraMachine = this.infraMachineService.read(Long.valueOf(1));

        String json = objectMapper.writeValueAsString(infraMachine);
        System.out.println(json);
    }

}