package com.loafle.overflow.central.module.infra.service;

import com.google.gson.Gson;
import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.infra.InfraOS;
import com.loafle.overflow.model.infra.InfraOSApplication;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.service.central.infra.InfraOSApplicationService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 7. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraOSApplicationServiceTest {

    @Autowired
    private InfraOSApplicationService infraOSApplicationService;

    @Autowired
    private ObjectMapper objectMapper;

//    @Ignore
    @Test
    public void regist() throws Exception {
        InfraOSApplication infraOSApplication = new InfraOSApplication();

        infraOSApplication.setName("Apache");

        InfraOS infraOS = new InfraOS();
        infraOS.setId(Long.valueOf(2));

        infraOSApplication.setInfraOS(infraOS);

        MetaInfraType metaInfraType = new MetaInfraType(4);

        this.infraOSApplicationService.regist(infraOSApplication);


        Assert.assertNotEquals(infraOSApplication.getId().longValue(), 0);

    }

    @Test
    public void read() throws Exception {

        InfraOSApplication infraOSApplication = this.infraOSApplicationService.read(Long.valueOf(1));

        Assert.assertNotNull(infraOSApplication);

        String json = objectMapper.writeValueAsString(infraOSApplication);
        System.out.println(json);

    }

}