package com.loafle.overflow.central.module.infra.service;

import com.google.gson.Gson;
import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.model.infra.InfraOS;
import com.loafle.overflow.model.infra.InfraOSDaemon;
import com.loafle.overflow.model.meta.MetaInfraType;
import com.loafle.overflow.service.central.infra.InfraOSDaemonService;

import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * Created by snoop on 17. 7. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraOSDaemonServiceTest {

    @Autowired
    private InfraOSDaemonService infraOSDaemonService;

    @Autowired
    private ObjectMapper objectMapper;

//    @Ignore
    @Test
    public void regist() throws Exception {

        InfraOSDaemon infraOSDaemon = new InfraOSDaemon();
        infraOSDaemon.setName("Apache");

        InfraOS infraOS = new InfraOS();
        infraOS.setId(Long.valueOf(2));

        infraOSDaemon.setInfraOS(infraOS);

        MetaInfraType metaInfraType = new MetaInfraType(5);

        this.infraOSDaemonService.regist(infraOSDaemon);

        Assert.assertNotEquals(infraOSDaemon.getId().longValue(), 0);

    }

    @Test
    public void read() throws Exception {

        InfraOSDaemon infraOSDaemon = this.infraOSDaemonService.read(Long.valueOf(1));
        Assert.assertNotNull(infraOSDaemon);

        String json = objectMapper.writeValueAsString(infraOSDaemon);
        System.out.println(json);

    }

}