package com.loafle.overflow.central.module.target.service;


import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.reflect.TypeToken;
import com.loafle.overflow.central.spring.AppConfigTest;

import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.service.central.target.TargetDiscoveryService;
import org.codehaus.jackson.map.DeserializationConfig;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.aop.support.AopUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ResourceLoader;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.lang.reflect.Method;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
*/

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class TargetDiscoveryServiceTest {

    @Autowired
    private ResourceLoader resourceLoader;

    @Autowired
    private TargetDiscoveryService targetDiscoveryService;

//     @Ignore
    @Test
    public void saveAllTarget() throws Exception {

        String json = readFileAsString(resourceLoader.getResource("classpath:2018-04-25-tds.json").getURI().getPath());

//         Gson gson = new GsonBuilder().registerTypeAdapter(Date.class, new JsonDateDeserializer()).create();


        ObjectMapper mapper = new ObjectMapper();

        mapper.configure(DeserializationConfig.Feature.FAIL_ON_UNKNOWN_PROPERTIES, false);

        List<Host> hosts = mapper.readValue(json, mapper.getTypeFactory().constructCollectionType(List.class, Host.class));


        Probe probe = new Probe();
        probe.setId(Long.valueOf(1));

        this.targetDiscoveryService.saveAllTarget(hosts, probe);
    }

    private String readFileAsString(String filePath) throws IOException {
        StringBuffer fileData = new StringBuffer();
        BufferedReader reader = new BufferedReader(
                new FileReader(filePath));
        char[] buf = new char[1024];
        int numRead=0;
        while((numRead=reader.read(buf)) != -1){
            String readData = String.valueOf(buf, 0, numRead);
            fileData.append(readData);
        }
        reader.close();
        return fileData.toString();
    }


    @Ignore
    @Test
    public void testParam() throws NoSuchMethodException {

        Method m = this.targetDiscoveryService.getClass().getMethod("saveAllTarget", List.class, Probe.class);
//        Method m = TargetDiscoveryService.class.getMethod("saveAllTarget", List.class, Probe.class);

        Class<?> clazz = AopUtils.getTargetClass(this.targetDiscoveryService);
        Method[] ms = clazz.getMethods();

        Method sm = null;
        for(Method mm : ms){
            if ("saveAllTarget".equals(mm.getName())) {
                sm = mm;
                break;
            }
        }

        if (sm != null) {
            Type[] ts = sm.getGenericParameterTypes();
            for(Type t : ts){
                if (t instanceof ParameterizedType) {
                    ParameterizedType pt = (ParameterizedType)t;
                    System.out.println(pt.getActualTypeArguments()[0].getTypeName());
                }
                System.out.println(t.getTypeName());


            }
        }


        System.out.println(m.getName());
        Type[] genericParameterTypes = m.getGenericParameterTypes();

        for(Type genericParameterType : genericParameterTypes){
            if(genericParameterType instanceof ParameterizedType){
                ParameterizedType aType = (ParameterizedType) genericParameterType;
                Type[] parameterArgTypes = aType.getActualTypeArguments();
                for(Type parameterArgType : parameterArgTypes){
                    Class parameterArgClass = (Class) parameterArgType;
                    System.out.println("parameterArgClass = " + parameterArgClass);
                }
            }
        }
    }

    @Ignore
    @Test
    public void testName() throws ClassNotFoundException {

        Object o = this.targetDiscoveryService;

        String nnn = o.getClass().getSimpleName();
        System.out.println(nnn);






    }

}